com.holonplatform.datastore.mongo.async.internal

## Class DefaultAsyncMongoDatastore

- java.lang.Object
- - com.holonplatform.core.internal.datastore.AbstractDatastore<X>
  - - com.holonplatform.core.internal.datastore.AbstractInitializableDatastore<X>
    - - com.holonplatform.datastore.mongo.core.internal.datastore.AbstractMongoDatastore<AsyncMongoDatastoreCommodityContext,com.mongodb.reactivestreams.client.ClientSession,TX,com.mongodb.reactivestreams.client.MongoDatabase>
      - - com.holonplatform.datastore.mongo.core.async.internal.AbstractAsyncMongoDatastore<AsyncMongoTransaction>
        - - com.holonplatform.datastore.mongo.async.internal.DefaultAsyncMongoDatastore

- All Implemented Interfaces:
    com.holonplatform.async.datastore.AsyncDatastore, com.holonplatform.async.datastore.transaction.AsyncTransactional, com.holonplatform.core.datastore.ConfigurableDatastore, com.holonplatform.core.datastore.DataContextBound, com.holonplatform.core.datastore.DatastoreCommodityContext, com.holonplatform.core.datastore.DatastoreCommodityHandler, com.holonplatform.core.datastore.DatastoreCommodityRegistrar<AsyncMongoDatastoreCommodityContext>, com.holonplatform.core.datastore.DatastoreExpressionResolverRegistrar, com.holonplatform.core.datastore.DatastoreOperations<CompletionStage<com.holonplatform.core.datastore.Datastore.OperationResult>,CompletionStage<com.holonplatform.core.property.PropertyBox>,com.holonplatform.async.datastore.operation.AsyncBulkInsert,com.holonplatform.async.datastore.operation.AsyncBulkUpdate,com.holonplatform.async.datastore.operation.AsyncBulkDelete,com.holonplatform.async.datastore.operation.AsyncQuery>, com.holonplatform.core.ExpressionResolver.ExpressionResolverHandler, com.holonplatform.core.ExpressionResolver.ExpressionResolverProvider, com.holonplatform.core.ExpressionResolver.ExpressionResolverSupport, AsyncMongoDatastore, BaseAsyncMongoDatastore, AsyncMongoDatastoreCommodityContext, MongoDatastoreCommodityContext<com.mongodb.reactivestreams.client.MongoDatabase,com.mongodb.reactivestreams.client.ClientSession>, MongoContext<com.mongodb.reactivestreams.client.ClientSession>, MongoOperationContext<com.mongodb.reactivestreams.client.MongoDatabase,com.mongodb.reactivestreams.client.ClientSession>, MongoDatabaseHandler<com.mongodb.reactivestreams.client.MongoDatabase>, Serializable

      public class DefaultAsyncMongoDatastore
      extends AbstractAsyncMongoDatastore<AsyncMongoTransaction>
      implements AsyncMongoDatastore

  Default `AsyncMongoDatastore` implementation.
  Since:
    5.2.0
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `DefaultAsyncMongoDatastore.DefaultBuilder`

    - ### Nested classes/interfaces inherited from class com.holonplatform.datastore.mongo.core.async.internal.AbstractAsyncMongoDatastore

      `AbstractAsyncMongoDatastore.AsyncBuilder<TX extends MongoTransaction<com.mongodb.reactivestreams.client.ClientSession>,I extends AbstractAsyncMongoDatastore<TX>,D extends com.holonplatform.core.datastore.DatastoreOperations,B extends BaseAsyncMongoDatastore.Builder<D,TX,B>>`

    - ### Nested classes/interfaces inherited from class com.holonplatform.datastore.mongo.core.internal.datastore.AbstractMongoDatastore

      `com.holonplatform.datastore.mongo.core.internal.datastore.AbstractMongoDatastore.AbstractBuilder<MDB,CX extends com.holonplatform.core.datastore.DatastoreCommodityContext,S extends com.mongodb.session.ClientSession,TX extends MongoTransaction<S>,I extends com.holonplatform.datastore.mongo.core.internal.datastore.AbstractMongoDatastore<CX,S,TX,MDB>,D extends com.holonplatform.core.datastore.DatastoreOperations,B extends MongoDatastoreBuilder<D,S,TX,B>>`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.datastore.mongo.async.AsyncMongoDatastore

      `AsyncMongoDatastore.Builder`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.datastore.DatastoreOperations

      `com.holonplatform.core.datastore.DatastoreOperations.WriteOption`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.datastore.DatastoreCommodityContext

      `com.holonplatform.core.datastore.DatastoreCommodityContext.CommodityConfigurationException, com.holonplatform.core.datastore.DatastoreCommodityContext.CommodityNotAvailableException`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultAsyncMongoDatastore()` Constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `toString()`
    `<R> CompletionStage<R>` | `withTransaction(com.holonplatform.async.datastore.transaction.AsyncTransactionalOperation<R> operation, com.holonplatform.core.datastore.transaction.TransactionConfiguration transactionConfiguration)`

    - ### Methods inherited from class com.holonplatform.datastore.mongo.core.async.internal.AbstractAsyncMongoDatastore

      `getClient, getClientSession, getDatabaseCodecRegistry, isAsync, setClient, withDatabase`

    - ### Methods inherited from class com.holonplatform.datastore.mongo.core.internal.datastore.AbstractMongoDatastore

      `getDatabaseName, getDefaultEnumCodecStrategy, getDefaultReadConcern, getDefaultReadPreference, getDefaultWriteConcern, getDocumentIdResolver, setDatabaseName, setDefaultReadConcern, setDefaultReadPreference, setDefaultWriteConcern, setDocumentIdResolver, setEnumCodecStrategy, setTransactionFactory, trace`

    - ### Methods inherited from class com.holonplatform.core.internal.datastore.AbstractInitializableDatastore

      `getInitializationClassLoader, initialize, isInitialized, setInitializationClassLoader`

    - ### Methods inherited from class com.holonplatform.core.internal.datastore.AbstractDatastore

      `addExpressionResolver, create, getAvailableCommodities, getCommodityFactoryType, getDataContextId, getExpressionResolvers, getExpressionResolverType, isTraceEnabled, registerCommodity, removeExpressionResolver, resolve, setDataContextId, setTraceEnabled`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.holonplatform.datastore.mongo.async.AsyncMongoDatastore

      `builder`

    - ### Methods inherited from interface com.holonplatform.datastore.mongo.core.MongoDatabaseHandler

      `withDatabase, withDatabase`

    - ### Methods inherited from interface com.holonplatform.core.datastore.DatastoreCommodityRegistrar

      `getCommodityFactoryType, registerCommodity`

    - ### Methods inherited from interface com.holonplatform.async.datastore.AsyncDatastore

      `bulkDelete, bulkInsert, bulkUpdate, delete, insert, isTransactional, query, query, refresh, requireTransactional, save, update`

    - ### Methods inherited from interface com.holonplatform.core.datastore.DatastoreCommodityHandler

      `create, getAvailableCommodities, hasCommodity`

    - ### Methods inherited from interface com.holonplatform.core.ExpressionResolver.ExpressionResolverSupport

      `addExpressionResolver, addExpressionResolvers, removeExpressionResolver`

    - ### Methods inherited from interface com.holonplatform.core.datastore.DataContextBound

      `getDataContextId`

    - ### Methods inherited from interface com.holonplatform.async.datastore.transaction.AsyncTransactional

      `withTransaction`

    - ### Methods inherited from interface com.holonplatform.datastore.mongo.core.config.MongoDatastoreCommodityContext

      `getDatabaseName`

    - ### Methods inherited from interface com.holonplatform.datastore.mongo.core.context.MongoContext

      `getDefaultEnumCodecStrategy, getDefaultReadConcern, getDefaultReadPreference, getDefaultWriteConcern, getDocumentIdResolver, toJson, toJson, toJson, trace, trace, trace, trace`

    - ### Methods inherited from interface com.holonplatform.core.ExpressionResolver.ExpressionResolverProvider

      `getExpressionResolvers`

- - ### Constructor Detail

    - #### DefaultAsyncMongoDatastore

          public DefaultAsyncMongoDatastore()

      Constructor.

  - ### Method Detail

    - #### withTransaction

          public <R> CompletionStage<R> withTransaction(com.holonplatform.async.datastore.transaction.AsyncTransactionalOperation<R> operation,
                                                        com.holonplatform.core.datastore.transaction.TransactionConfiguration transactionConfiguration)

      Specified by:
        `withTransaction` in interface `com.holonplatform.async.datastore.transaction.AsyncTransactional`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `com.holonplatform.core.internal.datastore.AbstractDatastore<AsyncMongoDatastoreCommodityContext>`

Copyright © 2019 The Holon Platform. All rights reserved.